CREATE TABLE MIESPACIO.EMP ( 
EMPNO NUMBER DEFAULT 0 , 
SAL NUMBER DEFAULT 0 , 
COMISION NUMBER DEFAULT 0 , 
ENOMBRE VARCHAR2(30) DEFAULT '' ,
JEFENO NUMBER DEFAULT 0 , 
DPTO NUMBER DEFAULT 0 ) 

CREATE OR REPLACE TRIGGER salario_emp
BEFORE INSERT OR UPDATE ON emp
FOR EACH ROW
DECLARE
total NUMBER;
BEGIN
--NVL(expresion, valor) --> Devuelve valor si expresion es nulo
SELECT NVL(SUM(sal),0) INTO total FROM  emp;
IF (INSERTING AND (total + :NEW.sal > 50000000)) THEN
	DBMS_OUTPUT.PUT_LINE('Sobrepasado lmite de salario al insertar en tabla de empleados');
	RAISE_APPLICATION_ERROR( -20001, 'Sobrepasado lmite de salario');
ELSIF (UPDATING('sal') AND (total + :NEW.sal - :OLD.sal > 50000000)) THEN
	DBMS_OUTPUT.PUT_LINE('Sobrepasado lmite de salario al modificar en tabla de empleados');
	RAISE_APPLICATION_ERROR( -20001, 'Sobrepasado lmite de salario' );
END IF;
END;