CREATE OR REPLACE TRIGGER CONTROL_LETRAS_EJ8
BEFORE INSERT OR UPDATE ON LETRAS_PRESTAMO
FOR EACH ROW
DECLARE
SALDO_CUENTA NUMBER;
CAPITAL NUMBER;
LETRAS NUMBER(5);
CUENTA NUMBER;
BEGIN
-- SACAMOS NUMERO DE CUENTA
SELECT CUENTA# INTO CUENTA 
FROM PRESTAMO 
WHERE PRESTAMO# = :NEW.PRESTAMO#;
-- COMPROBAMOS SALDO EN LA CUENTA
SELECT SALDO INTO SALDO_CUENTA FROM CUENTA WHERE CUENTA#=CUENTA;
IF (SALDO_CUENTA<:NEW.CAPITAL_AMORTIZADO) THEN
    DBMS_OUTPUT.PUT_LINE('SALDO ('|| SALDO_CUENTA ||') INSUFICIENTE PARA INGRESAR LETRA ('|| :NEW.CAPITAL_AMORTIZADO ||').');
    RAISE_APPLICATION_ERROR( -20001, 'SALDO INSUFICIENTE.' );
END IF;
-- ACTUALIZAMOS EL CAPITAL PENDIENTE DEL PRESTAMO
UPDATE PRESTAMO 
SET CAPITAL_PENDIENTE = CAPITAL_PENDIENTE - :NEW.CAPITAL_AMORTIZADO,
LETRAS_PENDIENTES = CEIL((CAPITAL_PENDIENTE - :NEW.CAPITAL_AMORTIZADO)/IMPORTE_LETRA)
WHERE PRESTAMO# = :NEW.PRESTAMO#;
-- SACAMOS LOS DATOS PARA ACTUALIZAR EL PRESTAMO
SELECT CAPITAL_PENDIENTE,LETRAS_PENDIENTES INTO CAPITAL,LETRAS
FROM PRESTAMO 
WHERE PRESTAMO# = :NEW.PRESTAMO#;
-- ACTUALIZAMOS EL SALDO DE LA CUENTA
UPDATE CUENTA 
SET SALDO = SALDO - :NEW.CAPITAL_AMORTIZADO
WHERE CUENTA# = CUENTA;
-- MENSAJES INFORMATIVOS DE CAPITAL PENDIENTE Y N DE LETRAS PENDIENTES
IF (CAPITAL>0) THEN 
    DBMS_OUTPUT.PUT_LINE( 'NUEVA AMORTIZACIN:' || :NEW.CAPITAL_AMORTIZADO || '. CAPITAL PENDIENTE: (' || CAPITAL || ')' );
END IF;
IF (LETRAS>0) THEN 
    DBMS_OUTPUT.PUT_LINE('FALTAN ' || LETRAS ||' POR PAGAR.');
END IF;
END;
